#include "BrowserEvents.h"

CWebBrowserEvents::CWebBrowserEvents()
{
    m_cRef = 1;
    m_hwndBrowser = ::FindWindow(TEXT("HTMLView"), NULL);
}

STDMETHODIMP CWebBrowserEvents::QueryInterface(REFIID riid, void** ppv)
{
    if (riid == IID_IUnknown)
    {
        *ppv = static_cast<IUnknown*>(this);
    }
    else if (riid == IID_IDispatch)
    {
        *ppv = static_cast<IDispatch*>(this);
    }
    else
    {
        *ppv = NULL;
        return (E_NOINTERFACE);
    }
    reinterpret_cast<IUnknown*>(*ppv)->AddRef();
    return (S_OK);
}


STDMETHODIMP_(ULONG) CWebBrowserEvents::AddRef()
{
    return (::InterlockedIncrement(&m_cRef));
}


STDMETHODIMP_(ULONG) CWebBrowserEvents::Release()
{
    if (::InterlockedDecrement(&m_cRef) == 0)
    {
        delete this;
        return (0);
    }
    return (m_cRef);
}

STDMETHODIMP CWebBrowserEvents::GetTypeInfoCount(
		UINT* pctinfo
		)
{
	return (S_OK);
}

STDMETHODIMP CWebBrowserEvents::GetTypeInfo(
		UINT iTInfo,
		LCID lcid,
		ITypeInfo** ppTInfo
		)
{
	return (S_OK);
}

STDMETHODIMP CWebBrowserEvents::GetIDsOfNames(
		const IID& riid,
		LPOLESTR* rgszNames,
		UINT cNames,
		LCID lcid,
		DISPID* rgDispId
		)
{
	return (S_OK);
}

STDMETHODIMP CWebBrowserEvents::Invoke(
		DISPID dispIdMember,
		const IID& riid,
		LCID lcid,
		WORD dwFlags,
		DISPPARAMS* pDispParams,
		VARIANT* pVarResult,
		EXCEPINFO* pExcepInfo,
		UINT* puArgErr
		)
{
	HRESULT hr = S_OK;
	switch(dispIdMember)
	{
	case BROWSER_EVENT_FRAME_BEFORE_NAVIGATE:
		break;

	case BROWSER_EVENT_FRAME_NAVIGATE_COMPLETE:
		break;

	case BROWSER_EVENT_BEFORE_NAVIGATE:
		break;

	case BROWSER_EVENT_NAVIGATE_COMPLETE:
		if (pDispParams->cArgs != 1)
		{
			hr = DISP_E_BADPARAMCOUNT;
			break;
		}
		if (pDispParams[0].rgvarg->vt != VT_BSTR)
		{
			hr = E_INVALIDARG;
			break;
		}
		break;

	default:
		break;
	}
	return (hr);
}
